<template>
  <FormControl :id="id" :label="label" :required="required" :error="error">
    <input
      v-show="!isPreview"
      :id="id"
      :name="id"
      :type="type"
      :placeholder="placeholder"
      :required="required"
      :value="value"
      @input="$emit('update', $event.target.value)"
    />
    <Paragraph
      v-if="isPreview"
      :text="previewValue ? previewValue : value"
      class="preview-text"
    />
  </FormControl>
</template>

<script>
import FormControl from "./FormControl";
import Paragraph from "../Paragraph";
import { isPreviewMixin } from "../../mixins/isPreview";
export default {
  name: "FormInput",
  components: { Paragraph, FormControl },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String,
      required: true
    },
    value: {
      type: String,
      required: true
    },
    type: {
      type: String,
      default: "text"
    },
    label: String,
    error: String,
    previewValue: String,
    placeholder: {
      type: String,
      default: "Enter"
    },
    required: {
      type: Boolean,
      default: true
    }
  },
  model: {
    prop: "value",
    event: "update"
  }
};
</script>

<style lang="scss"></style>
